138. Copy List with Random Pointer — LeetCode(Python)

Palash Sharma
3 min readJul 18, 2022

--

I got you!

Problem:

A linked list of length n is given such that each node contains an additional random pointer, which could point to any node in the list, or null.

Construct a deep copy of the list. The deep copy should consist of exactly n brand new nodes, where each new node has its value set to the value of its corresponding original node. Both the next and random pointer of the new nodes should point to new nodes in the copied list such that the pointers in the original list and copied list represent the same list state. None of the pointers in the new list should point to nodes in the original list.

For example, if there are two nodes X and Y in the original list, where X.random --> Y, then for the corresponding two nodes x and y in the copied list, x.random --> y.

Return the head of the copied linked list.

The linked list is represented in the input/output as a list of n nodes. Each node is represented as a pair of [val, random_index] where:

  • val: an integer representing Node.val
  • random_index: the index of the node (range from 0 to n-1) that the random pointer points to, or null if it does not point to any node.

Your code will only be given the head of the original linked list.

Example 1:

Input: head = [[7,null],[13,0],[11,4],[10,2],[1,0]]
Output: [[7,null],[13,0],[11,4],[10,2],[1,0]]

Example 2:

Input: head = [[1,1],[2,1]]
Output: [[1,1],[2,1]]

Example 3:

Input: head = [[3,null],[3,0],[3,null]]
Output: [[3,null],[3,0],[3,null]]

Constraints:

  • 0 <= n <= 1000
  • -104 <= Node.val <= 104
  • Node.random is null or is pointing to some node in the linked list.

Solution:

copy = {None:None}

curr = head

while curr:
node = Node(curr.val)
copy[curr] = node
curr = curr.next

curr = head

while curr:
node = copy[curr]
node.next = copy[curr.next]
node.random = copy[curr.random]
curr = curr.next

return copy[head]

Explanation —

We use the ever powerful hashmap to solve this problem.

We traverse the list to create copies of each node. Initially, we only copy the values since the pointers might point to nodes that don’t currently exist.

We create a mapping from each node in the old linked list to the corresponding node in the new linked list.

We traverse the old linked list again. This time, we copy the next and random pointers to our new list as well.

Finally, we return the value of the first key in our dictionary, which stores the head of our deep copy.

Time and Space Complexity —

Since, we are traversing each node in the linked list only twice, we can say that our code runs in linear time.

Also, we require a hashmap to store all nodes in the new linked list. So, it would require linear space as well.

Thus, if n is the length of the linked list,

Time Complexity: O(n)

Space Complexity: O(n)

Feel free to ask any related questions in the comment section or the links provided down below.

I don’t have friends:

Let’s be friends!

Connect with me on:

LinkedIn

GitHub

Instagram (I know. Very professional)

Jai Shri Ram 🙏

--

--